option explicit
option default integer
mode 1,8
page write 1
option console serial
cls
chdir "a:/Chess"
const a=1,b=2,c=3,d=4,e=5,f=6,g=7,h=8
const movedistance=2
const whiteking= 1
const whitequeen= 2
const whiterook= 3
const whiterook2= 4
const whitebishop= 5
const whitebishop2= 6
const whiteknight= 7
const whiteknight2= 8
const whitepawn= 9
const whitepawn2= 10
const whitepawn3= 11
const whitepawn4= 12
const whitepawn5= 13
const whitepawn6= 14
const whitepawn7= 15
const whitepawn8= 16
const blackking= 21
const blackqueen= 22
const blackrook= 23
const blackrook2= 24
const blackbishop= 25
const blackbishop2= 26
const blackknight= 27
const blackknight2= 28
const blackpawn= 29
const blackpawn2= 30
const blackpawn3= 31
const blackpawn4= 32
const blackpawn5= 33
const blackpawn6= 34
const blackpawn7= 35
const blackpawn8= 36
data whiterook,whiteknight,whitebishop,whitequeen,whiteking,whitebishop2,whiteknight2,whiterook2
data whitepawn,whitepawn2,whitepawn3,whitepawn4,whitepawn5,whitepawn6,whitepawn7,whitepawn8
data 0,0,0,0,0,0,0,0
data 0,0,0,0,0,0,0,0
data 0,0,0,0,0,0,0,0
data 0,0,0,0,0,0,0,0
data blackpawn,blackpawn2,blackpawn3,blackpawn4,blackpawn5,blackpawn6,blackpawn7,blackpawn8
data blackrook,blackknight,blackbishop,blackqueen,blackking,blackbishop2,blackknight2,blackrook2
dim board(8,8)
dim x,y
for y=1 to 8
  for x=1 to 8
    read board(x,y)
  next x
next y
const leftedge=100,square=75
load jpg "fpgJx",100,0
sprite loadpng whitequeen,"whitequeen"
sprite loadpng whiteking,"whiteking"
sprite loadpng whitebishop,"whitebishop"
sprite copy whitebishop,whitebishop2,1
sprite loadpng whiterook,"whiterook"
sprite copy whiterook, whiterook2,1
sprite loadpng whiteknight,"whiteknight"
sprite copy whiteknight,whiteknight2,1
sprite loadpng whitepawn,"whitepawn"
sprite copy whitepawn, whitepawn2,7
sprite loadpng blackqueen,"blackqueen"
sprite loadpng blackking,"blackking"
sprite loadpng blackbishop,"blackbishop"
sprite copy blackbishop,blackbishop2,1
sprite loadpng blackrook,"blackrook"
sprite copy blackrook,blackrook2,1
sprite loadpng blackknight,"blackknight"
sprite copy blackknight,blackknight2,1
sprite loadpng blackpawn,"blackpawn"
sprite copy blackpawn,blackpawn2,7
for y=1 to 8
  for x=1 to 8
    if board(x,y) then place board(x,y),x,y
  next x
next y
page copy 1 to 0,b

movepiece e,2,e,4
movepiece c,7,c,5
movepiece g,1,f,3
movepiece d,7,d,6
movepiece d,2,d,4
movepiece c,5,d,4
movepiece f,3,d,4
movepiece g,8,f,6
movepiece b,1,c,3
movepiece b,8,c,6
movepiece c,1,g,5
movepiece e,7,e,6
movepiece d,1,d,2
movepiece a,7,a,6
movepiece e,1,c,1
movepiece h,7,h,6
movepiece g,5,f,6
movepiece d,8,f,6
movepiece f,1,c,4
movepiece f,8,e,7
movepiece d,4,c,6
movepiece b,7,c,6
movepiece f,2,f,4
movepiece e,8,g,8
movepiece c,4,d,3
movepiece c,8,b,7
movepiece d,3,c,4
movepiece b,7,c,8
movepiece d,2,d,3

end
sub movepiece(x1,y1,x2,y2)
  if board(x1,y1)=0 then exit sub
  local w=sprite(W,board(x1,y1))
  local xold=(x1-1)*square+leftedge+square\2-w\2
  local yold=(8-y1)*square-3
  local xnew=(x2-1)*square+leftedge+square\2-w\2
  local ynew=(8-y2)*square-3
  local float angle=deg(atan2(yold-ynew,xold-xnew))-90
  vector 0,angle,0,xold,yold
  local float distancetomove=sqr((xold-xnew)^2 + (yold-ynew)^2)
  do while distancetomove>movedistance
    vector 0,angle,movedistance,xold,yold
    if board(x2,y2)<>0 and distancetomove<square then 
        sprite hide board(x2,y2)
        board(x2,y2)=0
    endif        
    sprite show board(x1,y1),xold,yold,1
    distancetomove=distancetomove-movedistance
    page copy 1 to 0,b
  loop
  if abs(x1-x2)=2 and (board(x1,y1)=blackking or board(x1,y1)=whiteking) then 'castle
    if x2=c then movepiece a,y1,d,y1
    if x2=g then movepiece h,y1,f,y1
  endif
  board(x2,y2)=board(x1,y1)
  board(x1,y1)=0  
  place board(x2,y2),x2,y2
  page copy 1 to 0,b
end sub
'
sub place(n,x,y)
  local w=sprite(W,n)
  local xoff=(x-1)*square+leftedge+square\2-w\2
  local yoff=(8-y)*square-3
  sprite show n,xoff,yoff,1
end sub
'
Sub vector(obj As integer, angle As float, distance As float, x_new As integer, y_new As integer)
  Static float y_move(9), x_move(9)
  Static float x_last(9), y_last(9)
  Static float last_angle(9)=(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1)
  If distance=0 Then
    x_last(obj)=x_new
    y_last(obj)=y_new
  EndIf
  If angle<>last_angle(obj) Then
    y_move(obj)=-Cos(Rad(angle))
    x_move(obj)=Sin(Rad(angle))
    last_angle(obj)=angle
  EndIf
  x_last(obj) = x_last(obj) + distance * x_move(obj)
  y_last(obj) = y_last(obj) + distance * y_move(obj)
  x_new=Cint(x_last(obj))
  y_new=Cint(y_last(obj))
Return
